﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace PuzzleGame_20121004
{
    class Box
    {
        private int number;

        private float x;
        private float y;

        private MainForm MF;

        private const int BoxSize = 50;
        private const int FontSize = 20;

        public Box(int number,float x,float y,MainForm MF) {
            this.x = x;
            this.y = y;
            this.number = number;
            this.MF = MF;

            this.MF.KeyDown += new System.Windows.Forms.KeyEventHandler(MF_KeyDown);
        }

        private void MF_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            switch (e.KeyCode) {
                case Keys.Up: Move(0, -1); break;
                case Keys.Down: Move(0, 1); break;
                case Keys.Left: Move(-1, 0); break;
                case Keys.Right: Move(1, 0); break;
            }
        }
        private void Move(float x_,float y_) {
            this.x += x_;
            this.y += y_;
            MF.Render();
        }
        
        public void Render() {
            int a = (int)Math.Log10(number);
            float pointX = x + (BoxSize / 2 - (FontSize / 2 + a * FontSize/2));
            float pointY = y + BoxSize / 2 - FontSize / 2;
            Pen _pen = new Pen(Brushes.Black);
            Font _font = new Font(new FontFamily("돋움"), FontSize, FontStyle.Bold, GraphicsUnit.Pixel);
            GDIBuffer.Instance().getGraphics.DrawString(number.ToString(), _font, new SolidBrush(Color.Black), new PointF(pointX, pointY));
            GDIBuffer.Instance().getGraphics.DrawRectangle(_pen, x, y, BoxSize, BoxSize);
        }
    }
}
